Index: trunk/expressoMail1_2/js/main.js
===================================================================
--- trunk/expressoMail1_2/js/main.js	(revision 5083)
+++ trunk/expressoMail1_2/js/main.js	(revision 5134)
@@ -5,4 +5,7 @@
 var autosave_time = 20000;
 
+var results_search_messages = ""; 
+var cabecalho = '<h4>ExpressoLivre - ExpressoMail</h4>'; 
+
 function init(){
 	if (!is_ie)
@@ -20,9 +23,16 @@
 
 		preferences = data;
+                
+		
+ 	                if(preferences.show_name_print_messages == "1") { 
+							var getUserName = document.getElementById("user_info"); 
+ 	                        var userName = getUserName.innerHTML; 
+ 	                        var position = userName.indexOf("-"); 
+ 	                        var userName = userName.substring(3, position); 
+ 	                        cabecalho = '<h4>' + userName; 
+ 	                }
+		
+		
 		current_folder="INBOX";
-                
-                version = (navigator.userAgent.match( /.+ie\s([\d.]+)/i ) || [])[1];
-		if(parseInt(version)==7 && (/trident\/\d/i.test(navigator.userAgent)))
-                        preferences.use_local_messages="0";
 		
 		if( (window.google && google.gears) && !google.gears.factory.getPermission())
@@ -318,5 +328,9 @@
 		// Call function to draw message
 		// If needed, delete old border
-		if (openTab.type[currentTab] == 2 || openTab.type[currentTab] == 3)
+                var isPartMsg = false;
+                for(var ii = 0; ii < partMsgs.length; ii++)
+                     if(partMsgs[ii] == ID) isPartMsg = true;               
+
+		if ((openTab.type[currentTab] == 2 || openTab.type[currentTab] == 3) && isPartMsg === false)
 			delete_border(currentTab,'false');
 
@@ -394,4 +408,5 @@
 		if(!verify_session(data))
 			return;
+		var total_messages_element = Element('tot_m');
 			
 		var box = Element("tbody_box");
@@ -415,7 +430,10 @@
 
 			var box = Element("tbody_box");
-			table_element.insertBefore(box, Element("colgroup_main_"+numBox)); // keeps colgroup as the last child
-
-			if (data.msgs_to_delete.length > 0)
+			//table_element.insertBefore(box, Element("colgroup_main_"+numBox)); // keeps colgroup as the last child
+			//table_element.appendChild(Element("colgroup_main_"+numBox));
+			
+			$(table_element).append(Element("colgroup_main_"+numBox));
+
+			if (data.msgs_to_delete.length > 0){
 				for (var i=0; i<data.msgs_to_delete.length; i++){
 					if ( (data.msgs_to_delete[i] != undefined) && (data.msgs_to_delete[i] != "")){
@@ -423,10 +441,7 @@
 					}
 				}
-
+			}
 			if (data[0].msg_folder != current_folder) // Bad request
 				return false;
-
-			var total_messages_element = Element('tot_m');
-
 			for (var i=0; i<data.length; i++){
 				var existent = document.getElementById(data[i].msg_number);
@@ -437,6 +452,10 @@
 					
 					if( data[i].next_msg_number != undefined && data[i].next_msg_number != null ){
-						try { box.insertBefore(new_msg, box.childNodes[data[i].msg_key_position]); }
-						catch (e) { box.insertBefore(new_msg, box.firstChild); }
+						try {
+							box.insertBefore(new_msg, box.childNodes[data[i].msg_key_position]);							
+						}
+						catch (e){
+							$(box).append(new_msg);
+						}
 					}
 					else if (data[i].Recent == 'N'){
@@ -446,12 +465,4 @@
 						box.appendChild(new_msg);
 					}
-//					if( data[i].next_msg_number != undefined && data[i].next_msg_number != null )
-//						box.insertBefore(new_msg, Element(data[i].next_msg_number));
-//					else if (data[i].Recent == 'N')
-//						box.insertBefore(new_msg,box.firstChild);
-//					else
-//						box.appendChild(new_msg);
-
-//					total_messages_element.innerHTML = parseInt( total_messages_element.innerHTML ) + 1;
 				}
 			}
@@ -460,4 +471,9 @@
 				alert(data['new_msgs'] > 1 ? get_lang("You have %1 new messages", data['new_msgs']) + "!" : get_lang("You have 1 new message") +"!");
 			build_quota(data['quota']);
+		}
+		if(data.new_msgs){
+			total_messages_element.innerHTML = parseInt( total_messages_element.innerHTML ) + data.new_msgs;
+		}else if(data.tot_msgs){
+			total_messages_element.innerHTML = data.tot_msgs;
 		}
 		// Update Box BgColor
@@ -494,5 +510,11 @@
 }
 
-	function delete_msgs(folder, msgs_number, border_ID, show_success_msg,archive){      
+function delete_msgs(folder, msgs_number, border_ID, show_success_msg,archive){
+			
+			if( preferences.use_local_messages == 1 && expresso_local_messages.isArchiving( msgs_number, folder ) ){
+			  alert( "Impossivel deletar mensagens que estão ainda estão sendo arquivadas." );
+			  return;
+			}
+				
  		        var userTrashFolder = ''; 
  		       
@@ -507,6 +529,9 @@
 				else userTrashFolder = 'INBOX'+cyrus_delimiter+trashfolder; 
  	 
- 		        if(openTab.type[currentTab] == 1) return move_search_msgs('content_id_'+currentTab,userTrashFolder,trashfolder); 
-				if(currentTab.toString().indexOf("_r") != -1) msgs_number = currentTab.toString().substr(0,currentTab.toString().indexOf("_r")); 
+ 		        if(openTab.type[currentTab] == 1) 
+					return move_search_msgs('content_id_'+currentTab,userTrashFolder,trashfolder); 
+					
+				if(currentTab.toString().indexOf("_r") != -1) 
+					msgs_number = currentTab.toString().substr(0,currentTab.toString().indexOf("_r")); 
  		         
  		        if (!archive && (parseInt(preferences.save_deleted_msg)) && (folder != userTrashFolder)){ 
@@ -574,4 +599,10 @@
 
 function move_search_msgs(border_id, new_folder, new_folder_name){
+  
+	if( preferences.use_local_messages == 1 && expresso_local_messages.isArchiving( msgs_number, folder ) ){
+	  alert( "Impossivel mover mensagens que estão ainda estão sendo arquivadas." );
+	  return;
+	}
+
 	var selected_messages = '';
 	var temp_msg;
@@ -663,5 +694,11 @@
 }
 
-function move_msgs2(folder, msgs_number, border_ID, new_folder, new_folder_name,show_success_msg){
+function move_msgs2(folder, msgs_number, border_ID, new_folder, new_folder_name,show_success_msg, not_opem_previus){
+	not_opem_previus = typeof(not_opem_previus) != 'undefined' ? not_opem_previus : false;
+	if( preferences.use_local_messages == 1 && expresso_local_messages.isArchiving( msgs_number, folder ) ){
+	    alert( "Impossivel mover mensagens que estão ainda estão sendo arquivadas." );
+	    return;
+	}
+
 	if (! folder || folder == 'null')
 		folder = Element("input_folder_"+msgs_number+"_r") ? Element("input_folder_"+msgs_number+"_r").value : (openTab.imapBox[currentTab] ? openTab.imapBox[currentTab]:get_current_folder());
@@ -689,8 +726,10 @@
 		}
 		mail_msg = ( Element("divScrollMain_"+numBox) ) ? Element("divScrollMain_"+numBox).firstChild.firstChild : Element("divScrollMain_0").firstChild.firstChild;
-		if (data.msgs_number.length == 1)
+		if (data.msgs_number.length == 1){
 			write_msg(get_lang("The message was moved to folder ") + lang_folder(data.new_folder_name));
-		else
+		}
+		else{
 			write_msg(get_lang("The messages were moved to folder ") + lang_folder(data.new_folder_name));
+		}
 
 		if (openTab.type[currentTab] > 1){
@@ -701,11 +740,14 @@
 					var previous_msg = msg_to_delete.previousSibling.id;
 					//cExecute("$this.imap_functions.get_info_msg&msg_number="+previous_msg+"&msg_folder=" + current_folder, show_msg);
+					if(!not_opem_previus){
 					cExecute("$this.imap_functions.get_info_msg&msg_number="+previous_msg+"&msg_folder=" + url_encode(folder), show_msg);
+				}
 				}
 				else
 					delete_border(currentTab,'false');
 			}
-			else
+			else{
 				delete_border(currentTab,'false');
+			}
 			if(msg_to_delete)
 				mail_msg.removeChild(msg_to_delete);
@@ -715,4 +757,7 @@
 			if(box.childNodes.length > 0){
 				updateBoxBgColor(box.childNodes);
+			}
+			if(folder == get_current_folder()){
+				Element('tot_m').innerHTML = parseInt(Element('tot_m').innerHTML) - 1;
 			}
 			return;
@@ -770,7 +815,7 @@
 				delete_border(data.border_ID,'false');
 		}
-		if(folder == get_current_folder())
+		if(folder == get_current_folder()){
 			Element('tot_m').innerHTML = parseInt(Element('tot_m').innerHTML) - data.msgs_number.length;
-
+		}
 		refresh();
 	}
@@ -796,21 +841,58 @@
 		}
 
-	if(currentTab.toString().indexOf("_r") != -1){
-		msgs_number = currentTab.toString().substr(0,currentTab.toString().indexOf("_r"));
-                if(msgs_number.indexOf("_s1"))
-                           msgs_number = msgs_number.replace('_s1', '');
+	// se a aba estiver aberta e selecionada, apenas a msg da aba é movida
+	if(currentTab.toString().indexOf("_r") != -1)
+        {
+                //se a aba for aberta atraves de uma pesquisa
+                if(currentTab.toString().indexOf('_s') != -1)
+                   msgs_number = currentTab.toString().substr(0,currentTab.toString().indexOf('_s'));
+                else
+                    msgs_number = currentTab.toString().substr(0,currentTab.toString().indexOf('_r'));
 	}
 
 	if (parseInt(msgs_number) > 0 || msgs_number.length > 0){
-            var params = "&folder="+folder+"&msgs_number="+msgs_number+"&border_ID="+border_ID+"&sort_box_type="+sort_box_type+"&search_box_type="+search_box_type+"&sort_box_reverse="+sort_box_reverse+"&reuse_border="+border_ID+"&new_folder="+escape(new_folder)+"&new_folder_name="+escape(new_folder_name)+"&get_previous_msg="+preferences.delete_and_show_previous_message;
-            cExecute ("$this.imap_functions.move_messages",handler_move_msgs,params);
+		if(!not_opem_previus){
+			cExecute ("$this.imap_functions.move_messages&folder="+folder+"&msgs_number="+msgs_number+"&border_ID="+border_ID+"&sort_box_type="+sort_box_type+"&search_box_type="+search_box_type+"&sort_box_reverse="+sort_box_reverse+"&reuse_border="+border_ID+"&new_folder="+new_folder+"&new_folder_name="+new_folder_name+"&get_previous_msg="+preferences.delete_and_show_previous_message, handler_move_msgs);
+		}else{
+			cExecute ("$this.imap_functions.move_messages&folder="+folder+"&msgs_number="+msgs_number+"&border_ID="+border_ID+"&sort_box_type="+sort_box_type+"&search_box_type="+search_box_type+"&sort_box_reverse="+sort_box_reverse+"&reuse_border="+border_ID+"&new_folder="+new_folder+"&new_folder_name="+new_folder_name+"&get_previous_msg="+false, handler_move_msgs);
         }
-	else
+	}else
 		write_msg(get_lang('No selected message.'));
 
 }
 
-function move_msgs(folder, msgs_number, border_ID, new_folder, new_folder_name) {
-	move_msgs2(folder, msgs_number, border_ID, new_folder, new_folder_name,true);
+function move_msgs(folder, msgs_number, border_ID, new_folder, new_folder_name, not_opem_previus) {
+	move_msgs2(folder, msgs_number, border_ID, new_folder, new_folder_name,true, not_opem_previus);
+}
+
+//Caso deseja-se que não se abra a mensagem anterior independente da 
+//preferencia do usuario
+function move_msgs_not_previus(folder, msgs_number, border_ID, new_folder, new_folder_name) {
+	move_msgs2(folder, msgs_number, border_ID, new_folder, new_folder_name,true, true);
+}
+
+function normalizeMsgNumber( msgNumber ){
+  
+      if (msgNumber || msgNumber == 'selected')
+	  msgNumber = get_selected_messages();
+
+
+      // se a aba estiver aberta e selecionada, apenas a msg da aba é movida
+      if(currentTab.toString().indexOf("_r") != -1)
+      {
+	    //se a aba for aberta atraves de uma pesquisa
+	    if(currentTab.toString().indexOf('_s') != -1)
+		msgNumber = currentTab.toString().substr(0,currentTab.toString().indexOf('_s'));
+	    else
+		msgNumber = currentTab.toString().substr(0,currentTab.toString().indexOf('_r'));
+      }
+      
+      if (parseInt(msgNumber) <= 0 || msgNumber.length <= 0){
+	    write_msg(get_lang('No selected message.'));
+	    return( false );
+      }
+      
+      return( msgNumber );
+
 }
 
@@ -828,13 +910,90 @@
 		id_msgs = get_selected_messages();
 
+	if ( parseInt(id_msgs) <= 0 || id_msgs.length <= 0 )
+	    return write_msg(get_lang('No selected message.'));
+	
 	if(folder_dest=='local_root' || folder_dest==null) //Caso seja o primeiro arquivamento...
 		folder_dest = 'local_Inbox';
 
-	if (parseInt(id_msgs) > 0 || id_msgs.length > 0)
-		expresso_mail_sync.archive_msgs(folder,folder_dest,id_msgs);
-		//cExecute("$this.imap_functions.get_info_msgs&folder=" + folder + "&msgs_number=" + id_msgs , handler_arquivar_mensagens);
-	else
-		write_msg(get_lang('No selected message.'));
-
+	id_msgs = expresso_local_messages.checkArchived( id_msgs, folder_dest );
+
+	 if( !id_msgs ){
+	      write_msg( "Todas as mensagens já foram arquivadas anteriormente." );
+	      return;
+	  }
+  
+	document.getElementById("overlay").style.visibility = "visible";
+
+	var handler_arquivar_mensagens = function(data) {
+	  
+	    var msgs_info = [];
+	  
+	    for( var i = 0; i < data.length; i++ )
+		msgs_info[i] = connector.unserialize( data[i] );
+
+	    //vejo se já tinha mensagens locais
+	    var h = expresso_local_messages.has_local_mails();
+	    
+	    expresso_local_messages.insert_mails( msgs_info, folder_dest, function( s, f ){complete_archiving( s, f, h )} );
+
+	    document.getElementById("overlay").style.visibility = "hidden";
+	}
+
+	cExecute( "$this.imap_functions.get_info_msgs&folder=" + folder + "&msgs_number=" + id_msgs, handler_arquivar_mensagens );
+}
+
+function complete_archiving( success, fails, has_local_messages_before )
+{
+    var msgs_to_remove = {};
+    var target = 'INBOX' + cyrus_delimiter + trashfolder + cyrus_delimiter + 'tmpMoveToLocal';
+    
+    success = expresso_local_messages.select_mail( [ 'original_id', 'original_folder' ], success );
+
+    for (var i = 0; i < success.length; i++) {
+	
+	var msg_info = success[i];
+
+// 	if ( msg_info.dest_folder == target )
+// 	{
+// 		msg_info.msg_folder += (Date.parse(new Date));
+// 	}
+
+	//////////////// deselecionando ////////////////
+	Element('chk_box_select_all_messages').checked = false;
+
+	if ( Element("check_box_message_" + msg_info.original_id) ) 
+	{
+		Element("check_box_message_" + msg_info.original_id).checked = false;
+	}
+	if ( Element(msg_info.original_id) )
+	{
+		remove_className(Element(msg_info.original_id), 'selected_msg');
+	}
+
+// 	if ( tree_folders._selected.id.indexOf( 'local_' ) == 0 || msg_info.dest_folder.indexOf( target ) == 0 )
+// 	{
+// 		openTab.imapBox[0] = '';
+// 		tree_folders.getNodeById( 'local_Inbox' )._select( );
+// 		change_folder('local_Inbox','Inbox');
+// 	}
+	/////////////////////////////////////////////////
+
+	//As mensagens arquivadas devem ser removidas, caso o usuario tenha isso configurado.
+	msgs_to_remove[ msg_info.original_folder ] = msgs_to_remove[ msg_info.original_folder ] || [];
+	msgs_to_remove[ msg_info.original_folder ].push( msg_info.original_id );
+    }
+
+    if (preferences.keep_archived_messages == 0) {
+	    //Remove as mensagens
+	    for( var folder in msgs_to_remove ){
+		if(folder != 'undefined')
+			delete_msgs(folder, msgs_to_remove[folder],'null',false,true);
+	    }
+    }
+
+    if( !has_local_messages_before && expresso_local_messages.has_local_mails() )
+	    ttreeBox.update_folder();
+    else
+	    update_menu();
 }
 
@@ -853,11 +1012,7 @@
 
 	// Get all TR (messages) in tBody.
-        if(currentTab.toString().indexOf("_r") != -1){
-            return currentTab.toString().substr(0,currentTab.toString().indexOf("_r"));
-        }
-
 	var main_list = main.childNodes;
 
-	var _check_box;
+	var _tab_prefix = getTabPrefix();
 	var selected_messages = '';
 	var selected_messages_by_shortcuts = '';
@@ -865,7 +1020,13 @@
 	for (j; j<(main_list.length); j++)
 	{
-		_check_box = Element("check_box_message_" + main_list[j].id);
-
-		if ( (_check_box) && (_check_box.checked) )
+
+if ( (!isNaN(parseInt(numBox))) && (numBox == 0)) { 
+ 		                        check_box = Element("check_box_message_" + main_list[j].id); 
+ 		                } else { 
+ 		                        id_mensagem = main_list[j].id.split('_'); 
+								check_box = Element("search_" + numBox + "_check_box_message_" + id_mensagem[0]); 
+ 		                }        
+ 		                 
+ 		                if ( (check_box) && (check_box.checked) ) 
 		    selected_messages += main_list[j].id + ',';
 
@@ -880,4 +1041,14 @@
 	selected_messages = selected_messages.substring(0,(selected_messages.length-1));
 
+ 		         
+ 		        /* Verifica se está na tela de pesquisa. */ 
+ 		        if(selected_messages.indexOf("_") != -1) 
+ 		        { 
+ 		                results_search_messages = selected_messages; 
+ 		                /* Retira a informação da aba */ 
+ 		                selected_messages = selected_messages.substring(0,selected_messages.indexOf("_"));
+	}
+	
+
 	if (preferences.use_shortcuts == '1')
 	{
@@ -897,42 +1068,4 @@
 	else
 		return selected_messages;
-}
-
-function get_selected_messages_folder(){
-	var _main;
-	var _main_list;
-	try{
-		_main = document.getElementById("divScrollMain_"+numBox).firstChild.firstChild;
-	}catch(e){
-	};
-
-	if (! _main)
-		_main = Element("tbody_box_"+numBox);
-
-	if (! _main)
-		_main = Element("tbody_box");
-
-	// Get all TR (messages) in tBody.
-	_main_list = _main.childNodes;
-
-	var _check_box;
-	var selected_messages_folder;
-//	var selected_messages_by_shortcuts = '';
-	var j = 0;
-	for (j; j<(_main_list.length); j++)
-	{
-
-		_check_box = Element("check_box_message_" + _main_list[j].id);
-
-		if ( (_check_box) && (_check_box.checked) && (_main_list[j].name) ) {
-			if (!selected_messages_folder)
-				selected_messages_folder = _main_list[j].name;
-			else {
-				if (selected_messages_folder!=_main_list[j].name)
-					return false;
-			}
-		}
-	}
-	return selected_messages_folder;
 }
 
@@ -971,5 +1104,5 @@
 					9 : get_lang("Reply without history"),
 					10: get_lang("Reply to all without history")};
-
+			if(new_border_ID != 0)
 			if(!confirm(get_lang("Your message to %1 has not been saved or sent. "+
 						"To %2 will be necessary open it again. Discard your message?",
@@ -982,4 +1115,8 @@
 			}
 		}
+	}
+	if (new_border_ID == 'maximo'){
+		RichTextEditor.editorReady = true;
+		return false;
 	}
 	if (new_border_ID == false)
@@ -1039,4 +1176,7 @@
 	if (document.getElementById("subject_" + border_ID))
 		data.subject = document.getElementById("subject_" + border_ID).innerHTML;
+	if(data.subject == get_lang("(no subject)   "))
+		data.subject = '';
+		
 	if (document.getElementById("body_" + border_ID))
 		data.body = document.getElementById("body_" + border_ID).innerHTML;
@@ -1052,6 +1192,8 @@
 		data.date_hour = Element('date_hour_' + border_ID).value;
 	}
+        
 	var signature = RichTextEditor.getSignatureDefault();
-	if(type!="new" && type!="edit")
+        
+	if(type!="new" && type!="edit" && document.getElementById("is_local_"+border_ID) != null)
 		data.is_local_message = (document.getElementById("is_local_"+border_ID).value=="1")?true:false;
 	switch(type){
@@ -1061,5 +1203,15 @@
 			title = "Re: " + data.subject;
 			Element("subject_" + new_border_ID).value = "Re: " + data.subject;			
-			useOriginalAttachments(new_border_ID,border_ID,data.is_local_message);
+
+	if (data.is_local_message){  
+		alert(get_lang("In the local file attachments, including images, will be disregarded. To forward / reply with the attachments, please first make the reopening of the message")+'.');  
+        var imagens = data.body.match(/<img[^>]*>/g);  
+        if(imagens != null)  
+			for (var x = 0; x < imagens.length; x++)  
+				data.body = data.body.replace(imagens[x],'');  
+	}else{
+		useOriginalAttachments(new_border_ID,border_ID);			
+	}      
+
 			// Insert the signature automaticaly at message body if use_signature preference is set
 			if (preferences.use_signature == "1"){  
@@ -1077,5 +1229,14 @@
 			Element("subject_" + new_border_ID).value = "Re: " + data.subject;
 			Element("to_" + new_border_ID).value = data.to;
-			useOriginalAttachments(new_border_ID,border_ID,data.is_local_message);
+			if(data.is_local_message){
+				alert(get_lang("In the local file attachments, including images, will be disregarded. To forward / reply with the attachments, please first make the reopening of the message")+'.');  
+                var imagens = data.body.match(/<img[^>]*>/g);  
+                if(imagens != null)  
+					for (var x = 0; x < imagens.length; x++)  
+						data.body = data.body.replace(imagens[x],'');  
+			}else{
+				useOriginalAttachments(new_border_ID,border_ID);
+			}
+			
 			block_quoted_body = make_body_reply(data.body, data.to, data.date_day, data.date_hour);
 			// Insert the signature automaticaly at message body if use_signature preference is set
@@ -1112,5 +1273,13 @@
 				Element('space_link_' + new_border_ID).style.display='none';
 			}
-			useOriginalAttachments(new_border_ID,border_ID,data.is_local_message);
+			if (data.is_local_message){  
+				alert(get_lang("In the local file attachments, including images, will be disregarded. To forward / reply with the attachments, please first make the reopening of the message")+'.');  
+                var imagens = data.body.match(/<img[^>]*>/g);  
+                if(imagens != null)  
+					for (var x = 0; x < imagens.length; x++)  
+						data.body = data.body.replace(imagens[x],'');  
+                     }      
+                else useOriginalAttachments(new_border_ID,border_ID);  
+
 			// Insert the signature automaticaly at message body if use_signature preference is set
 			if (preferences.use_signature == "1")  
@@ -1160,5 +1329,5 @@
 			break;
 		case "forward":
-			data.is_local_message = (document.getElementById("is_local_"+border_ID).value=="1")?true:false;
+			
 			msg_forward_from = document.createElement('input');
 			msg_forward_from.id = "msg_forward_from_" + new_border_ID;
@@ -1169,9 +1338,24 @@
 			document.getElementById("subject_" + new_border_ID).value = "Fw: " + data.subject;
 			var divFiles = Element("divFiles_"+new_border_ID);
+			
+			
+			if (data.is_local_message) {//Local messages  
+				document.getElementById("is_local_forward"+new_border_ID).value = "1";  
+                alert(get_lang("In the local file attachments, including images, will be disregarded. To forward / reply with the attachments, please first make the reopening of the message")+'.');  
+                var imagens = data.body.match(/<img[^>]*>/g);  
+                if(imagens != null)  
+					for (var x = 0; x < imagens.length; x++)  
+						data.body = data.body.replace(imagens[x],'');    
+                    }
+                else{  
+
+			
+			
 			var campo_arquivo;
+                        
 			if (Element("attachments_" + border_ID)){
 				var attachments = document.getElementById("attachments_" + border_ID).getElementsByTagName("a");
 				
-				for (var i = (attachments.length > 1 ? 1 : 0); i < attachments.length; i++){
+				for (var i = 0; i < attachments.length; i++){
 					if((attachments[i].tagName=="SPAN") || (attachments[i].tagName=="IMG") ||
 							((attachments[i].href.indexOf("javascript:download_local_attachment")==-1)&&(attachments[i].href.indexOf("javascript:download_attachments")==-1)))
@@ -1191,6 +1375,6 @@
 						}
 						else {
-							var tempNomeArquivo = attachments[i].firstChild.nodeValue.split("(");
-							var nomeArquivo = trim(tempNomeArquivo[0]);
+							var tempNomeArquivo = tmp.split("&newfilename=");
+							var nomeArquivo = tempNomeArquivo[tempNomeArquivo.length - 1];
 						}
 
@@ -1218,6 +1402,7 @@
 				}
 			}
+			}
 			// Insert the signature automaticaly at message body if use_signature preference is set
-if (preferences.use_signature == "1")   
+			if (preferences.use_signature == "1")  
  		                            RichTextEditor.setInitData(new_border_ID,'<div><br type="_moz"></div>' + signature + '<div><br type="_moz"></div>'+ make_forward_body(data.body, data.to, data.date, data.subject, data.to_all, data.cc)); 
  		                        else   
@@ -1266,10 +1451,14 @@
 			Element("to_" + new_border_ID).value = data.to;
 			if (data.cc){
+				data.cc = data.cc.replace(/&lt;/gi,"<");
+				data.cc = data.cc.replace(/&gt;/gi,">");
 				Element("cc_" + new_border_ID).value = data.cc;
-				Element("space_link_" + new_border_ID).style.display = 'none';
 				Element("a_cc_link_" + new_border_ID).style.display = 'none';
+				if(Element("cco_" + new_border_ID) != null)
+					Element("space_link_" + new_border_ID).style.display = 'none';
 				Element("tr_cc_"+ new_border_ID).style.display = '';
 			}
 			if (data.cco){
+				if(Element("cco_" + new_border_ID) != null){
 				Element("cco_" + new_border_ID).value = data.cco;
 				Element("space_link_" + new_border_ID).style.display = 'none';
@@ -1277,4 +1466,5 @@
 				Element("tr_cco_"+ new_border_ID).style.display = '';
 			}
+			}
 			Element("subject_" + new_border_ID).value = data.subject;
 			
@@ -1284,5 +1474,7 @@
 			var element_important_message = Element("important_message_" + new_border_ID);
 			if(element_important_message) {
-				if(Element("is_important_" + border_ID).value == "1") element_important_message.checked = true;
+					
+				if(Element("disposition_important_" + border_ID))
+					element_important_message.checked = true;				
 			}
 
@@ -1301,5 +1493,6 @@
 					tmp = link_attachment.innerHTML.substring(0,link_attachment.innerHTML.lastIndexOf("("));
 					a_tmp[2] = "'"+tmp.substring(0,tmp.length-1)+"'";
-					s_tmp = trim(escape(connector.serialize(a_tmp)));
+					s_tmp = escape(connector.serialize(a_tmp));
+
 					divFiles.innerHTML += "<input style='border:0' type='CHECKBOX' name='forwarding_attachments[]' checked value=\""+s_tmp+"\"/>";
 					divFiles.appendChild(link_attachment);
@@ -1315,5 +1508,6 @@
 	set_border_caption("border_id_" + new_border_ID, title);
 
-
+	resizeWindow();
+	//save_msg(new_border_ID);
 	return new_border_ID; //Preciso retornar o ID da nova mensagem.
 }
@@ -1484,15 +1678,14 @@
 	{
 		var handler = function(data){
-                        if(typeof(expresso_local_messages) != "undefined"){
+
 			if(data.msg_day == '')
 			{
 				header=expresso_local_messages.get_msg_date(data.original_ID, proxy_mensagens.is_local_folder(get_current_folder()));
-                                if(header){
+
 				data.fulldate=header.fulldate;
 				data.smalldate=header.smalldate;
 				data.msg_day = header.msg_day;
 				data.msg_hour = header.msg_hour;
-			}
-			}
+
                       }
 			this.show_msg(data);
@@ -1564,8 +1757,27 @@
 	mail_as_plain = ( mail_as_plain ) ? mail_as_plain.checked : false;
 
+       var content_body  = RichTextEditor.getData('body_'+ID);
+       //Remove imagens do corpo que estao com o checkbox desmarcados
+       var files_checkbox =  $("#divFiles_"+ID+" input:checkbox");
+       var files_unchecked = new Array();
+       for (var i = 0; i < files_checkbox.length; i++)
+            if(files_checkbox[i].checked !== true)
+                files_unchecked.push(connector.unserialize(unescape(trim(files_checkbox[i].value))));
+
+       var imagens = content_body.match(/<img[^>]*>/g);
+       
+       if(imagens != null)
+            for (var x = 0; x < imagens.length; x++)
+                for (var xx = 0; xx < files_unchecked.length; xx++)
+                    if(imagens[x].indexOf('indexPart='+files_unchecked[xx][3].replace(/'/g,'')) !== -1)
+                         content_body = content_body.replace(imagens[x],'');
+                
+        //--------------------------------------------------------------------------//
+        
 	var textArea = document.createElement("TEXTAREA");
 	textArea.style.display='none';
 	textArea.name = "body";
-	textArea.value = RichTextEditor.getData('body_'+ID); 
+	textArea.value = content_body;
+   
 	var input_folder = document.createElement("INPUT");
 	input_folder.style.display='none';
@@ -1633,6 +1845,35 @@
 		handler_send_message(data_return,ID);
 	}
-	else
+	else{
 		cExecuteForm("$this.imap_functions.send_mail", form, handler_send_message, ID);
+	}
+}
+function is_valid_email(campo){	
+	var invalidEmail = searchEmail(campo);
+	var semicolon = campo.split(";");
+	
+	if((campo.replace(/^\s+|\s+$/g,"")) != ""){
+			if(invalidEmail[0] == true){
+				write_msg("Erro de SMTP: Os endereços de destinatário a seguir falharam: "+ invalidEmail[1]);
+				return false;
+			}else{
+				if(semicolon.length > 1){
+					var stringError = "Erro de SMTP: Os endereços devem ser separados apenas por vígula: ";
+					for(var i= 0; i < semicolon.length; i++){
+						stringError = stringError + semicolon[i];
+						if(i+1 < semicolon.length)
+							stringError = stringError + " ; ";
+					}
+					write_msg(stringError);
+					return false;
+				}else {
+					return true;
+				}
+			}
+	}
+	else{
+		write_msg(get_lang("Message without receiver"));
+		return false;
+	}		
 }
 function change_tr_properties(tr_element, newUid, newSubject){
@@ -1657,13 +1898,18 @@
 {
 	Element("send_button_"+border_id).style.visibility="visible";
-	var handler_delete_msg = function(data){refresh(preferences.alert_new_msg);};
-
- 	if (data == null || data.append != true )
+	var handler_delete_msg = function(data){refresh(preferences.alert_new_msg);RichTextEditor.execPosInstance('body_'+border_id);};
+        if(data === null)
 	{
-		RichTextEditor.saveFlag = 0;
-		if (! data.append)
-                    if(data == 'Post-Content-Length')
-                        write_msg(get_lang('The size of this message has exceeded  the limit (%1B).', preferences.max_attachment_size ? preferences.max_attachment_size : Element('upload_max_filesize').value));
-		else
+            write_msg(get_lang('ERROR saving your message.'));
+            return null;
+        }
+
+	if(data.append === "Over quota"){
+		write_msg(get_lang('ERROR saving your message over quota.'));
+		return;
+	}
+	else if ( data.append !== true )
+	{
+		if (data.append == null)
                     write_msg(get_lang('ERROR saving your message.'));
 		else
